(* EXERCICE 4*)

let rec puiss a b = 
	if b = 0 then 1
	else a * puiss a (b-1)

let rec reste a b =
	if a < b then a
	else reste (a-b) b

let rec pgcd a b = 
	if b = 0 then a 
	else pgcd b (a mod b)

let rec puiss_rapide a b =
	if b = 0 then 1
	else let r = puiss_rapide (a*a) (b/2) in
         if b mod 2 = 1 then a * r
         else r

let rec div_eucl a b = 
	if a < b then (0, a)
	else let (q, r) = div_eucl (a-b) b in 
		 (q + 1, r)	

(* booléen indiquant si f a une racine entière entre a et b inclus *)
let rec a_racine f a b = 
	if a > b then false
	else f a = 0 || a_racine f (a+1) b

(* bonus: modifier la fonction précédente
   pour qu'elle renvoie une racine.
   On veut donc une fonction
   racine: (int -> int) -> int -> int -> int *)
let rec racine f a b = 
	if a > b then failwith "Pas de racine"
	else if f a = 0 then a
	else racine f (a+1) b

